﻿using BA.Core.Configuration.Grid.Columns;
using BA.Core.Configuration.Grid.Renderers;
using BA.Core.CriteriaOperators;
using BA.Core.CustomAttributes;
using BA.Core.Interfaces;
using $safeprojectname$.Configuration.Grid.Controls;
using DevExpress.Data.Filtering;
using DevExpress.Web.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace $safeprojectname$.Configuration.Grid.Renderer
{
    [GridColumnControlRenderer(typeof(DefaultValueTextColumn))]
    public class DefaultValueTextColumnDefaultRenderer : IGridColumnControlRenderer
    {
        /// <inheritdoc/>
        public bool CanColumnBeRendered(GridColumnBase column)
        {
            return true;
        }

        /// <inheritdoc/>
        public IEnumerable<GridViewQueryColumnProperties> GetQueryProperties(GridColumnBase column)
        {
            DefaultValueTextColumn defaultTextColumn = (DefaultValueTextColumn)column;
            string columnName = GridRendererHelper.GetDataColumnBaseGridColumnName(defaultTextColumn);
            Type dataType = GridRendererHelper.GetDataColumnBaseDataType(defaultTextColumn);

            CriteriaOperator criteria;
            if (!string.IsNullOrEmpty(defaultTextColumn.DefaultValue))
            {
                CriteriaOperator fieldValue = GridRendererHelper.GetDataColumnBaseCriteria(defaultTextColumn);
                CriteriaOperator expression = fieldValue == new OperandValue(null);
                CriteriaOperator thenPart = new OperandValue(defaultTextColumn.DefaultValue.Translate());
                CriteriaOperator elsepart = fieldValue;
                criteria = new FunctionOperator(FunctionOperatorType.Iif, expression, thenPart, elsepart);
            }
            else
                criteria = GridRendererHelper.GetDataColumnBaseCriteria(defaultTextColumn);

            return new[] { new GridViewQueryColumnProperties { Name = columnName, DataType = dataType, Criteria = criteria } };
        }

        public IEnumerable<MVCxGridViewColumn> GetRenderColumns(GridColumnBase column, GridViewRendererParameter parameter)
        {
            DefaultValueTextColumn defaultTextColumn = (DefaultValueTextColumn)column;
            MVCxGridViewColumn gridColumn = GridRendererHelper.CreateDataBaseRenderColumn(defaultTextColumn, parameter);
            gridColumn.PropertiesEdit.EncodeHtml = defaultTextColumn.EncodeHTML;
            return new[] { gridColumn };
        }
    }
}