﻿using BA.API;
using BA.Core.Configuration.OrmEntity;
using BA.Core.Models;
using $safeprojectname$.DB;
using $safeprojectname$.Enums.Extensions;
using DevExpress.Xpo;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace $safeprojectname$.Controllers
{
    public class TrainingHelperController : Controller
    {
        [Authorize]
        public ActionResult CreateEngineRecord(string DefaultName, Guid? SelectedOid)
        {
            // Session mit temporären Schlüssel anlegen
            Guid tempKey = Guid.NewGuid();
            UnitOfWork uow = Api.ORM.GetNewUnitOfWork(tempKey);

            // Neuen Datensatz erstellen
            OrmEngine myData = Api.ORM.GetNewORM<OrmEngine>(uow);

            if (SelectedOid != null && SelectedOid != Guid.Empty)
            {
                // Name vorbelegen. Entweder wird der Name das Datensatzes genommen, welcher über SelectedOid definiert ist
                OrmEngine selectedOrm = Api.ORM.GetOrm<OrmEngine>((Guid)SelectedOid, uow);
                myData.Name = selectedOrm.Name;
            }
            else
                // Oder der konfigurierte Wert
                myData.Name = DefaultName;

            // Betreuer Relation auf den aktuellen Benutzer setzen.
            RelationData relationDataSource = Api.ORM.GetRelationDataModel(uow, Api.User.CurrentUserProfileGuid());
            myData.AddSource(relationDataSource, EnumRelationTypeExtension.Responsible.ValueGuid, null);

            // Datensatz 'speichern'.
            myData.Save();
            uow.CommitChanges();

            // Datensatz in den Cache legen
            Guid cacheGuid = myData.SaveToCache();

            // Datentabellenkonfiguration laden, um die Vorgabemaske zu ermitteln
            OrmEntityConfiguration entityConfig = Api.Config.TryOrmEntity(EnumDataSourceExtension.Engine.ValueGuid);

            // Datensatz in der Maske öffnen
            return RedirectToAction("Index", entityConfig.CorrespondingFormConfiguration, new { id = myData.Oid, TemporaryKey = tempKey, cacheId = cacheGuid });
        }
    }
}