﻿using BA.Core.CriteriaOperators;
using DevExpress.Data.Filtering;
using DevExpress.Data.Linq;
using System;
using System.Linq;
using System.Linq.Expressions;

namespace $safeprojectname$.CriteriaOperators.Functions
{
    public class WriteTextOperator : ICriteriaOperatorBAFunction
    {
        public const string Name = "BATWriteText";

        string ICustomFunctionOperator.Name => Name;

        /// <inheritdoc/>
        public Type ResultType(params Type[] operands) => typeof(object);

        /// <inheritdoc/>
        public virtual Expression Convert(ICriteriaToExpressionConverter converter, params Expression[] operands)
        {
            if (operands.Length == 1 && operands[0].Type == typeof(string))
                return Expression.Default(typeof(string));

            throw new ArgumentException("Die Funktion BATWriteText benötigt einen Parameter");
        }

        /// <inheritdoc/>
        public virtual object Evaluate(params object[] operands)
        {
            if (operands.Length == 1 && operands[0] is string operand1)
                return operand1;

            throw new ArgumentException("Die Funktion BATWriteText benötigt einen Parameter");
        }

        /// <inheritdoc/>
        public virtual CriteriaOperator GetCriteriaDB(FunctionOperator function)
        {
            if (function.Operands.Count == 2 && function.Operands[1] is OperandValue value && value.Value is string strValue)
            {
                return new OperandValue(strValue);
            }

            throw new ArgumentException("Die Funktion BATWriteText benötigt einen Parameter");
        }
    }
}