declare module BA.Ui.Controls {
    class HTMLControlEvents {
        private static popUp;
        private static htmlEditor;
        private static editorTarget;
        /**
         * Fired when dialog for upload image or insert link is created (but before dialog is shown)
         * @param s Handle of html control
         * @param e event arguments
         */
        static DialogInitialzed(s: BAClientHtmlEditor, e: ASPxClientHtmlEditorDialogInitializedEventArgs): void;
        /**
         * Init mehthod of html control
         * We attach on every ancor tag a onclick function
         * @param s Handle of html control
         * @param e event arguments
         */
        static OnInit(s: BAClientHtmlEditor, e: ASPxClientEventArgs): void;
        static OnPopUpInit(s: BAClientPopupControl, e: ASPxClientEventArgs): void;
        static OnChanged(s: BAClientHtmlEditor, e: ASPxClientEventArgs): void;
        /**
         * Commands of the context menu and toolbox (no custom tools) in html editor
         */
        static OnCommandExecuting: (s: any, e: any) => void;
        static OnCommandExecuted: (s: BAClientHtmlEditor, e: any) => void;
        /**
         * On custom command. It must be handled
         */
        static OnCustomCommand: (s: BAClientHtmlEditor, e: any) => void;
    }
}
