interface String {
    startsWith: (prefix: string) => boolean;
    endsWith: (suffix: string) => boolean;
    format(...replacements: string[]): string;
}
interface CustomData {
    [key: string]: Object;
}
interface TranslationDictionary {
    [key: string]: string;
}
interface GridLastClickedInfo {
    [key: string]: number;
}
interface GIConfiguration {
    base_url: string;
    app_base_url: string;
    start_page_url: string;
    current_user_id: string;
    attachmentEditSettingsDocx: string;
    attachmentEditSettingsXlsx: string;
    attachmentEditSettingsPdf: string;
    configurationName: string;
    configurationType: string;
}
declare class GridRowItem {
    RowOrmType: string;
    RowOrmOid: string;
    constructor(rowOrmType: string, rowOrmOid: string);
}
declare enum GridAmmountSelected {
    None = 0,
    One = 1,
    MoreThanOne = 2
}
interface BAClientFileManager extends MVCxClientFileManager {
    GetSelectedFile(): BAClientFileManagerFile;
    DeletedItems: any;
    cpAttachmentCaption: string;
    cpAttachments: any;
    cpTotalFileSize: any;
    cpShowFileSize: boolean;
    cpShowType: any;
    cpSingleClickFunction: any;
    cpClassName: string;
    cpControlPrefix: string;
    cpFieldName: string;
}
interface BAClientControl extends ASPxClientControl {
    /** Returns the popup control element this button belongs to */
    GetParentControl(): BAClientControl;
}
interface BAClientHtmlEditor extends MVCxClientHtmlEditor {
    OnPost(): any;
}
interface BAClientRibbon extends ASPxClientRibbon {
    CustomData: {
        [key: string]: any;
    };
    items: any;
}
interface BAClientRibbonItem extends ASPxClientRibbonItem {
    type: number;
    showPopup: Function;
    items: any[];
    info: any;
    ribbon: BAClientRibbon;
}
interface BAClientRibbonTab extends ASPxClientRibbonTab {
    getTabControlTab(): any;
}
interface BARibbonClientEvent extends ASPxClientEvent<ASPxClientRibbonCommandExecutedEventHandler<ASPxClientRibbon>> {
    removeHandlerByControlName(name: any): any;
}
interface BAClientGridView extends MVCxClientGridView {
    cpADMoreResults: boolean;
    cpConfiguredHeight: number;
    cpGridGuid: string;
    cpGridsDataSources: string;
    cpHideGrid: boolean;
    cpBreadCrumbDivID: string;
    cpDrillDownEnabled: boolean;
    cpFilterRowVisible: boolean;
    cpBreadCrumbCollectionJson: string;
    ContextMenuShowSearchPanel(boolean: any): any;
    cpSearchPanelVisible: boolean;
    cpFooterVisible: boolean;
    cpShowColumnHeaders: boolean;
    cpDrillDownTypes: string;
    cpGridModelAdditionalData: string;
    SelectItem(p1: any, p2: any): any;
    GetFilterRow(): any;
    GetCurrentPageIndices(): any;
    ChangeItemStyle(visibleIndex: any, rowStyle: any): any;
    ContextMenuShowFilterRowMenu(p1: boolean): any;
    ContextMenuShowFilterRow(p1: any): any;
    cpDoubleClickFunction: any;
    cpGroupPanelVisible: boolean;
    ContextMenuShowFooter(visible: boolean): any;
    ContextMenuShowGroupPanel(visible: boolean): any;
    GetRow(index: number): HTMLElement;
    GetKeyValues(): any;
    cpDetailGrid: any;
    cpSingleClickFunction: any;
    UA_UpdateEdit: any;
    lastMultiSelectIndex: any;
    cpGridLayoutConfiguration: any;
    GetSearchEditor(): any;
    deleteItemUrl: string;
    cpFilterExpression: string;
    cpSearchPanelFilter: string;
    cpIsAsControl: boolean;
    cpTranslationGrid: string;
    cpControlReadonly: boolean;
    cpAllCombinedGrids: any;
    contextMenuHelper: any;
    cpOpenBehavior: any;
    cpAutoRefresh: boolean;
    cpTranslationGridSearch: string;
    cpDnDType: string;
    cpFormConfigurationGuid: string;
    cpOverrideSingleClickFunction: string;
    cpOverrideDoubleClickFunction: string;
    cpDuplicateSearchInformation: string;
    cpClearSelectionOnSearch: boolean;
    GetColumnIndexByDataCell(htmlTarget: any): number;
    cpPrimaryRecordGuid: string;
    cpFilterRelationDefinition: string;
    cpRelationToPrimaryRecord: string;
    cpRecordId: string;
    cpFilterRecords: string[];
    cpShallowDeletionCheck: boolean;
    GetSelectedKeysOnPage(): BA.Classes.Guid[] | string[];
}
interface BAClientPopupControl extends MVCxClientPopupControl {
    cpMessage: string;
    cpButton: any;
    cpCaption: string;
    cpAllowResize: boolean;
    allowResize: boolean;
    cpShowFooter: boolean;
    cpIcon: any;
    CloseOnEscape: any;
    cpRefreshParentGrid: any;
    cpDialogTitle: string;
}
interface BAClientTreeList extends MVCxClientTreeList {
    cpTreeBuildingSources: any;
    GetRowByNodeKey(string: any): any;
    cpStartingType: any;
    FocusedNodeType: any;
    cpSetFocusToNodeKey: string;
}
interface BAClientCallbackPanel extends MVCxClientCallbackPanel {
    cpNotDirty: boolean;
    cpWarningMessage: string;
    cpContainingGrids: any;
    cpFields: string[];
    cpRefreshGroupName: string;
    cpAdditionalOnChange: string;
    cpRefreshInitiators: string[];
    cpControlsWithCompanions: string[];
    cpCompanionsOfControls: string[];
}
interface BAClientHiddenField extends ASPxClientHiddenField {
    GetValue(): any;
}
interface BAClientTokenBox extends MVCxClientTokenBox {
    cpAutoSubmit: any;
    UpdateStateHiddenField(): any;
    RaiseCloseUp(): void;
    GetTokenValuesCollection(): Array<string>;
    cpAllowCustomTokens: boolean;
    cpMaximumSelectionCount: number;
    cpFormConfigurationId: string;
    cpControlId: string;
}
interface BAClientComboBox extends MVCxClientComboBox {
    cpMutuallyExclusiveList: string;
    cpAutoSubmit: any;
    cpHasNavigateToConfigurationBtn: boolean;
    cpInitCanNavigateToConfiguration: boolean;
}
interface BAClientRadioButtonList extends ASPxClientRadioButtonList {
    cpSelectedItem: any;
    cpAdditionalOnChange: string;
}
interface BAClientFilterEditorProperty extends ASPxClientButtonEdit {
    cpOrmType: string;
    cpDialogTitle: string;
    cpIsLite: boolean;
    cpOrmExists: boolean;
    GetErrorCell(): any;
}
interface BAClientButtonProperty extends ASPxClientButton {
    cpDialog: string;
    cpDefaultRecurring: boolean;
    cpCompanionField: string;
    cpDialogTitle: string;
    cpDialogCaption: string;
    cpModelType: string;
    cpFilterResource: string;
    cpFilterResourcePreselected: string;
    cpStartField: string;
    cpShowMessages: boolean;
    cpControlName: string;
}
interface BAClientDropDownEdit extends ASPxClientDropDownEdit {
    cpBaseName: string;
}
interface BAClientFilterEditor extends ASPxClientFilterControl {
    ChangeGroup(group: any, index: any): any;
    OnCallbackFinalized(): any;
    GetActiveCallbacksInfo(): any;
}
interface BAClientCheckBoxList extends ASPxClientCheckBoxList {
    cpSelectedItems: any;
    cpAutoSubmit: any;
}
interface BAClientListBox extends ASPxClientListBox {
    cpSelectedItems: any;
}
interface BAClientTextBox extends ASPxClientTextBox {
    cpCompanionField: string;
    CustomData: any;
}
interface BAClientFileManagerFile extends ASPxClientFileManagerFile {
    index: any;
    cpControlPrefix: string;
}
interface BAClientPanel extends ASPxClientPanel {
    updateDocumentPaddings(): any;
}
interface BAJQuery extends JQuery {
    matchHeight(p1: Object): any;
}
interface BAPickListSelectionGridInformation {
    SelectionGrid: string;
    FilterId: string;
    FilterRelation: string;
    FilterRelationCategory: string;
}
interface BASortableTokenBoxControl_AddToken {
    (oid: string, title: string, type: string): void;
}
interface BAClientCheckBox extends ASPxClientCheckBox {
    cpAutoSubmit: boolean;
    cpAdditionalOnChange: string;
}
interface BAClientScheduler extends MVCxClientScheduler {
    cpGridDataSources: any;
    cpGridsDataSources: any;
    cpConfigurationId: string;
    cpFormGuid: string;
    cpOpenBehavior: string;
    cpAutoRefresh: boolean;
    cpCanCreateNew: boolean;
    cpDurationEditable: boolean;
    cpCalendarLayoutConfiguration: string;
    cpShowStatusInToolTip: {
        [key: string]: boolean;
    };
    cpFilterResource: string;
    cpFilterStatus: string;
    cpFilterLabel: string;
    cpFilterSelectedStatus: string[];
    cpFilterSelectedLabel: string[];
    cpFilterSelectedResource: string[];
    cpResourceAsEnum: boolean;
    cpFilterStatusCaption: string;
    cpFilterLabelCaption: string;
    cpFilterResourceCaption: string;
    cpFilterResourceFieldName: string;
    cpFilterResourceDataTables: string;
    cpCalendarGroupType: string;
    cpInitTimeIntervals: {
        [key: string]: string;
    };
    cpAdditionalSettings: string;
    cpRecurrenceExceptionsAllowed: boolean;
    GetAppointmentById(id: string): BAClientAppointment;
}
interface BAClientAppointment extends ASPxClientAppointment {
    cpExceptionId: string;
    cpDefaultFormGuid: string;
    cpOrmType: string;
    cpCanEdit: boolean;
    cpIsRecurring: boolean;
}
interface BASortableTokenBoxControl extends ASPxClientControl {
    AddToken: BASortableTokenBoxControl_AddToken;
    ClearNullText(): void;
    ContainsToken(oid: string): boolean;
    GetBackEndValue(): BA.Ui.Controls.Token[];
    GetBackEndValueRaw(): string;
    GetInputElement(): HTMLSpanElement;
    GetIsValid(): boolean;
    GetValue(): string;
    InternalGetDialogSelectionGridInformation(): BAPickListSelectionGridInformation[];
    RemoveToken(oid: string): void;
    SetBackEndValue(tokens: BA.Ui.Controls.Token[]): void;
    SetBackEndValueRaw(tokens: string): void;
    SetErrorText(text: string): void;
    SetIsValid(valid: boolean): void;
    SetValue(currentHtml: string): void;
    SyncBackEndToUi(): void;
    SyncUiToBackEnd(): void;
    cpGridSelectionDisplayMode: string;
    cpDialogSelectionGrids: string[];
    cpFilterId: string;
    cpFilterRelationSubType: string;
    cpFilterRelationType: string;
    cpOverrideFilterIds: boolean;
    cpRefreshGroupName: string;
    cpNullText: string;
    cpDialogTitle: string;
    cpDialogDescription: string;
    cpMinSelect: number;
    cpMaxSelect: number;
    cpSortable: boolean;
    mainElement: HTMLSpanElement;
}
interface Window {
    updateTabs: () => any;
    onShow: () => any;
    onHide: () => any;
    onRemove: () => any;
    toastr: Toastr;
    ProgressBar: any;
    FormContent: any;
    tabController: BA.Ui.TabController.Controller;
    translationTools: BA.Ui.Translations.TranslationTools;
    duplicateService: BA.Ui.Duplicates.DuplicateService;
    showNagScreen: boolean;
    tabProgressStyles: any;
    ButtonSubmit: ASPxClientButton;
    DialogButtonSubmit: ASPxClientButton;
    btnSubmitGridExport: ASPxClientButton;
    btnOk: ASPxClientButton;
    btnCancel: ASPxClientButton;
    btnDelete: ASPxClientButton;
    onResize: any;
    onReady: any;
    onAfterReady: any;
    onSaveSuccess: any;
    onSaveError: any;
    Historyjs: Historyjs;
    MessageBoxPopUp: BAClientPopupControl;
    Spreadsheet: MVCxClientSpreadsheet;
    TreeList: BAClientTreeList;
    RichEdit: MVCxClientRichEdit;
    Ribbon: BAClientRibbon;
    GridView: BAClientGridView;
    DesignTreeCallback: BAClientCallbackPanel;
    RecordCacheId: BAClientTextBox;
    ToolboxTreeList: BAClientTreeList;
    DesignTreeList: BAClientTreeList;
    ConfigurationPreviewPopup: BAClientPopupControl;
    FormTools: BA.Ui.Form.FormTools;
    FormTabTitle: BAClientTextBox;
    FormTabIcon: BAClientTextBox;
    ASPx: any;
    AttachmentDeletedAttachments: BAClientTextBox;
    activeDirectoryRecordsGrid: BAClientGridView;
    DestinationGrid: BAClientGridView;
    popupControl: BAClientPopupControl;
    NewRecordOid: BAClientHiddenField;
    giConfiguration: GIConfiguration;
    isOutlook: boolean;
    pdfManagement: BA.Ui.PDFManagement;
    ClientData: HTMLInputElement;
    SelectedForm: HTMLInputElement;
    temporaryKey: HTMLInputElement;
    Filter: BAClientTextBox;
    Configuration: BAClientTextBox;
    PropertiesPanel: BAClientCallbackPanel;
    HeaderPane: BAClientPanel;
    RibbonPane: BAClientPanel;
    Name: BAClientTextBox;
    Public: ASPxClientCheckBox;
    Default: ASPxClientCheckBox;
    FormLoadingPanel: ASPxClientLoadingPanel;
    Cookies: any;
}
